3 # Rewrite revision history
4 # Copyright (c) Petr Baudis, 2006
5 # Minimal changes to "port" it to core-git (c) Johannes Schindelin, 2007
7 # Lets you rewrite the revision history of the current branch, creating
8 # a new branch. You can specify a number of filters to modify the commits,
11 # The following functions will also be available in the commit filter:
13 functions
=$
(cat << \EOF
20 # if it was not rewritten, take the original
21 if test -r "$workdir/../map/$1"
23 cat "$workdir/../map/$1"
29 # if you run 'skip_commit "$@"' in a commit filter, it will print
30 # the (mapped) parents, effectively skipping the commit.
43 # if you run 'git_commit_non_empty_tree "$@"' in a commit filter,
44 # it will skip commits that leave the tree untouched, commit the other.
45 git_commit_non_empty_tree
()
47 if test $# = 3 && test "$1" = $
(git rev-parse
"$3^{tree}"); then
53 # override die(): this version puts in an extra line break, so that
54 # the progress is still visible
67 # When piped a commit, output a script to set the ident of either
68 # "author" or "committer
71 lid
="$(echo "$1" | tr "[A-Z
]" "[a-z
]")"
72 uid
="$(echo "$1" | tr "[a-z
]" "[A-Z
]")"
77 s/^'$lid' \([^<]*\) <[^>]*> .*$/\1/
79 s
/.
*/GIT_
'$uid'_NAME
='\''&'\''; export GIT_
'$uid'_NAME
/p
82 s
/^
'$lid' [^
<]* <\
([^
>]*\
)> .
*$
/\
1/
84 s/.*/GIT_'$uid'_EMAIL='\''&'\''; export GIT_'$uid'_EMAIL/p
87 s/^'$lid' [^<]* <[^>]*> \(.*\)$/\1/
89 s
/.
*/GIT_
'$uid'_DATE
='\''&'\''; export GIT_
'$uid'_DATE
/p
95 LANG=C LC_ALL=C sed -ne "$pick_id_script"
96 # Ensure non-empty id name.
97 echo "case \"\$GIT_${uid}_NAME\" in \"\") GIT_${uid}_NAME=\"\${GIT_${uid}_EMAIL%%@*}\" && export GIT_${uid}_NAME;; esac"
100 USAGE="[--env-filter <command>] [--tree-filter <command>]
101 [--index-filter <command>] [--parent-filter <command>]
102 [--msg-filter <command>] [--commit-filter <command>]
103 [--tag-name-filter <command>] [--subdirectory-filter <directory>]
104 [--original <namespace>] [-d <directory>] [-f | --force]
105 [<rev-list options>...]"
110 if [ "$(is_bare_repository)" = false ]; then
111 git diff-files --ignore-submodules --quiet &&
112 git diff-index --cached --quiet HEAD -- ||
113 die "Cannot rewrite branch(es) with a dirty working directory."
125 orig_namespace=refs/original/
157 # all switches take one argument
159 case "$#" in 1) usage ;; esac
172 filter_tree="$OPTARG"
175 filter_index="$OPTARG"
178 filter_parent="$OPTARG"
184 filter_commit="$functions; $OPTARG"
187 filter_tag_name="$OPTARG"
189 --subdirectory-filter)
190 filter_subdir="$OPTARG"
194 orig_namespace=$(expr "$OPTARG/" : '\
(.
*[^
/]\
)/*$
')/
202 case "$prune_empty,$filter_commit" in
204 filter_commit='git commit-tree
"$@"';;
206 filter_commit="$functions;"' git_commit_non_empty_tree
"$@"';;
210 die "Cannot set --prune-empty and --filter-commit at the same time"
218 test -d "$tempdir" &&
219 die "$tempdir already exists, please remove it"
221 mkdir -p "$tempdir/t" &&
222 tempdir="$(cd "$tempdir"; pwd)" &&
227 # Remove tempdir on exit
228 trap 'cd ..
/..
; rm -rf "$tempdir"' 0
230 ORIG_GIT_DIR="$GIT_DIR"
231 ORIG_GIT_WORK_TREE="$GIT_WORK_TREE"
232 ORIG_GIT_INDEX_FILE="$GIT_INDEX_FILE"
234 export GIT_DIR GIT_WORK_TREE
236 # Make sure refs/original is empty
237 git for-each-ref > "$tempdir"/backup-refs || exit
238 while read sha1 type name
240 case "$force,$name" in
242 die "Cannot create a new backup.
243 A previous backup already exists in $orig_namespace
244 Force overwriting the backup with -f"
247 git update-ref -d "$name" $sha1
250 done < "$tempdir"/backup-refs
252 # The refs should be updated if their heads were rewritten
253 git rev-parse --no-flags --revs-only --symbolic-full-name \
254 --default HEAD "$@" > "$tempdir"/raw-heads || exit
255 sed -e '/^^
/d
' "$tempdir"/raw-heads >"$tempdir"/heads
257 test -s "$tempdir"/heads ||
258 die "Which ref do you want to rewrite?"
260 GIT_INDEX_FILE="$(pwd)/../index"
261 export GIT_INDEX_FILE
262 git read-tree || die "Could not seed the index"
264 # map old->new commit ids for rewriting parents
265 mkdir ../map || die "Could not create map/ directory"
267 # we need "--" only if there are no path arguments in $@
268 nonrevs=$(git rev-parse --no-revs "$@") || exit
269 test -z "$nonrevs" && dashdash=-- || dashdash=
270 rev_args=$(git rev-parse --revs-only "$@")
272 case "$filter_subdir" in
274 eval set -- "$(git rev-parse --sq --no-revs "$@")"
277 eval set -- "$(git rev-parse --sq --no-revs "$@" $dashdash \
282 git rev-list --reverse --topo-order --default HEAD \
283 --parents --simplify-merges $rev_args "$@" > ../revs ||
284 die "Could not get the commits"
285 commits=$(wc -l <../revs | tr -d " ")
287 test $commits -eq 0 && die "Found nothing to rewrite"
289 # Rewrite the commits
291 git_filter_branch__commit_count=0
292 while read commit parents; do
293 git_filter_branch__commit_count=$(($git_filter_branch__commit_count+1))
294 printf "\rRewrite $commit ($git_filter_branch__commit_count/$commits)"
296 case "$filter_subdir" in
298 git read-tree -i -m $commit
301 # The commit may not have the subdirectory at all
302 err=$(git read-tree -i -m $commit:"$filter_subdir" 2>&1) || {
303 if ! git rev-parse -q --verify $commit:"$filter_subdir"
305 rm -f "$GIT_INDEX_FILE"
311 esac || die "Could not initialize the index"
315 git cat-file commit "$commit" >../commit ||
316 die "Cannot read commit $commit"
318 eval "$(set_ident AUTHOR <../commit)" ||
319 die "setting author failed for commit $commit"
320 eval "$(set_ident COMMITTER <../commit)" ||
321 die "setting committer failed for commit $commit"
322 eval "$filter_env" < /dev/null ||
323 die "env filter failed: $filter_env"
325 if [ "$filter_tree" ]; then
326 git checkout-index -f -u -a ||
327 die "Could not checkout the index"
328 # files that $commit removed are now still in the working tree;
329 # remove them, else they would be added again
330 git clean -d -q -f -x
331 eval "$filter_tree" < /dev/null ||
332 die "tree filter failed: $filter_tree"
335 git diff-index -r --name-only $commit &&
336 git ls-files --others
337 ) > "$tempdir"/tree-state || exit
338 git update-index --add --replace --remove --stdin \
339 < "$tempdir"/tree-state || exit
342 eval "$filter_index" < /dev/null ||
343 die "index filter failed: $filter_index"
346 for parent in $parents; do
347 for reparent in $(map "$parent"); do
348 parentstr="$parentstr -p $reparent"
351 if [ "$filter_parent" ]; then
352 parentstr="$(echo "$parentstr" | eval "$filter_parent")" ||
353 die "parent filter failed: $filter_parent"
356 sed -e '1,/^$
/d
' <../commit | \
357 eval "$filter_msg" > ../message ||
358 die "msg filter failed: $filter_msg"
359 @SHELL_PATH@ -c "$filter_commit" "git commit-tree" \
360 $(git write-tree) $parentstr < ../message > ../map/$commit ||
361 die "could not write rewritten commit"
364 # If we are filtering for paths, as in the case of a subdirectory
365 # filter, it is possible that a specified head is not in the set of
366 # rewritten commits, because it was pruned by the revision walker.
367 # Ancestor remapping fixes this by mapping these heads to the unique
368 # nearest ancestor that survived the pruning.
370 if test "$remap_to_ancestor" = t
374 sha1=$(git rev-parse "$ref"^0)
375 test -f "$workdir"/../map/$sha1 && continue
376 ancestor=$(git rev-list --simplify-merges -1 "$ref" "$@")
377 test "$ancestor" && echo $(map $ancestor) >> "$workdir"/../map/$sha1
378 done < "$tempdir"/heads
381 # Finally update the refs
383 _x40='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
384 _x40="$_x40$_x40$_x40$_x40$_x40$_x40$_x40$_x40"
388 # avoid rewriting a ref twice
389 test -f "$orig_namespace$ref" && continue
391 sha1=$(git rev-parse "$ref"^0)
392 rewritten=$(map $sha1)
394 test $sha1 = "$rewritten" &&
395 warn "WARNING: Ref '$ref' is unchanged" &&
400 echo "Ref '$ref' was deleted"
401 git update-ref -m "filter-branch: delete" -d "$ref" $sha1 ||
402 die "Could not delete $ref"
405 echo "Ref '$ref' was rewritten"
406 if ! git update-ref -m "filter-branch: rewrite" \
407 "$ref" $rewritten $sha1 2>/dev/null; then
408 if test $(git cat-file -t "$ref") = tag; then
409 if test -z "$filter_tag_name"; then
410 warn "WARNING: You said to rewrite tagged commits, but not the corresponding tag."
411 warn "WARNING: Perhaps use '--tag-name-filter cat' to rewrite the tag."
414 die "Could not rewrite $ref"
419 # NEEDSWORK: possibly add -Werror, making this an error
420 warn "WARNING: '$ref' was rewritten into multiple commits:"
422 warn "WARNING: Ref '$ref' points to the first one now."
423 rewritten=$(echo "$rewritten" | head -n 1)
424 git update-ref -m "filter-branch: rewrite to first" \
425 "$ref" $rewritten $sha1 ||
426 die "Could not rewrite $ref"
429 git update-ref -m "filter-branch: backup" "$orig_namespace$ref" $sha1 ||
431 done < "$tempdir"/heads
433 # TODO: This should possibly go, with the semantics that all positive given
434 # refs are updated, and their original heads stored in refs/original/
437 if [ "$filter_tag_name" ]; then
438 git for-each-ref --format='%(objectname
) %(objecttype
) %(refname
)' refs/tags |
439 while read sha1 type ref; do
440 ref="${ref#refs/tags/}"
441 # XXX: Rewrite tagged trees as well?
442 if [ "$type" != "commit" -a "$type" != "tag" ]; then
446 if [ "$type" = "tag" ]; then
447 # Dereference to a commit
449 sha1="$(git rev-parse -q "$sha1"^{commit})" || continue
452 [ -f "../map/$sha1" ] || continue
453 new_sha1="$(cat "../map/$sha1")"
456 new_ref="$(echo "$ref" | eval "$filter_tag_name")" ||
457 die "tag name filter failed: $filter_tag_name"
459 echo "$ref -> $new_ref ($sha1 -> $new_sha1)"
461 if [ "$type" = "tag" ]; then
462 new_sha1=$( ( printf 'object
%s
\ntype commit
\ntag
%s
\n' \
463 "$new_sha1" "$new_ref"
464 git cat-file tag "$ref" |
471 -e '/^
-----BEGIN PGP SIGNATURE----
-/q
' \
474 die "Could not create new tag object for $ref"
475 if git cat-file tag "$ref" | \
476 sane_grep '^
-----BEGIN PGP SIGNATURE-----
' >/dev/null 2>&1
478 warn "gpg signature stripped from tag object $sha1t"
482 git update-ref "refs/tags/$new_ref" "$new_sha1" ||
483 die "Could not write tag $new_ref"
492 unset GIT_DIR GIT_WORK_TREE GIT_INDEX_FILE
493 test -z "$ORIG_GIT_DIR" || {
494 GIT_DIR="$ORIG_GIT_DIR" && export GIT_DIR
496 test -z "$ORIG_GIT_WORK_TREE" || {
497 GIT_WORK_TREE="$ORIG_GIT_WORK_TREE" &&
500 test -z "$ORIG_GIT_INDEX_FILE" || {
501 GIT_INDEX_FILE="$ORIG_GIT_INDEX_FILE" &&
502 export GIT_INDEX_FILE
505 if [ "$(is_bare_repository)" = false ]; then
506 git read-tree -u -m HEAD || exit